varying vec2 textureCoordinate;

uniform sampler2DRect inputImageTexture;
uniform mat3 colorConversionMatrix;

void main()
{
    vec4 vyuy = texture2DRect(inputImageTexture, textureCoordinate);
    vec3 yuv;
    if (mod(textureCoordinate.x * 2.0, 2.0) > 0.6) {
        yuv = vyuy.abr;
    } else {
        yuv = vyuy.gbr;
    }
    yuv = yuv - vec3(16.0/255.0, 0.5, 0.5);
    
    vec3 rgb = colorConversionMatrix * yuv;
    
    gl_FragColor =  vec4(rgb, 1.0);
}